package fr.inria.phoenix.diasuite.framework.context.hvacregulation;

import java.io.Serializable;

/**
 * Container for the indices of the context <code>HVACRegulation</code>.
 * 
 * <pre>
 * context HVACRegulation as TemperatureLevel indexed by location as String {
 * 	when provided AverageTemperature 
 * 	get targetTemperature from ControlPanel,
 * 		status from HVACSystem
 * 	maybe publish;
 * }
 * </pre>
 */
public final class HVACRegulationIndices implements Serializable {
    private static final long serialVersionUID = 0;
    
    public HVACRegulationIndices(java.lang.String location) {
        this._location = location;
    }
    
    // Code for index location
    private java.lang.String _location;
    
    /**
     * Get the <code>location</code> index
     * 
     * @return the value of the <code>location</code> index
     */
    public java.lang.String location() {
        return _location;
    }
    
    /**
     * Set the <code>location</code> index
     * 
     * @param newLocation the new value for the <code>location</code> index
     */
    public void setLocation(java.lang.String newLocation) {
        this._location = newLocation;
    }
    // End of code for index location
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((_location == null) ? 0 : _location.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        HVACRegulationIndices other = (HVACRegulationIndices) obj;
        if (_location == null) {
            if (other._location != null)
                return false;
        } else if (!_location.equals(other._location))
            return false;
        return true;
    }
}
