package fr.inria.phoenix.diasuite.framework.mocks;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.device.hvacsystem.AbstractHVACSystem;

// @internal
public final class HVACSystemMock {
    
    /**
     * The timeout in milliseconds to wait action. Set it if your application computations are long.
     */
    public long TIMEOUT = Mock.TIMEOUT;
    
    class Proxy extends AbstractHVACSystem {
        private Proxy(ServiceConfiguration serviceConfiguration,
                java.lang.String idValue,
                java.lang.String locationValue,
                java.lang.String userValue) {
            super(serviceConfiguration, idValue, locationValue, userValue);
        }
        
        public void _updateId(java.lang.String newIdValue) {
            updateId(newIdValue);
        }
        
        public void _updateLocation(java.lang.String newLocationValue) {
            updateLocation(newLocationValue);
        }
        
        public void _updateUser(java.lang.String newUserValue) {
            updateUser(newUserValue);
        }
        
        protected java.lang.Boolean getIsAlive() throws Exception {
            java.lang.Boolean result = __isAlive;
            if(result == null)
                return super.getIsAlive();
            return result;
        }
        
        public void _publishIsAlive(java.lang.Boolean newIsAliveValue) {
            publishIsAlive(newIsAliveValue);
        }
        
        protected fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus getStatus() throws Exception {
            fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus result = __status;
            if(result == null)
                return super.getStatus();
            return result;
        }
        
        public void _publishStatus(fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus newStatusValue) {
            publishStatus(newStatusValue);
        }
        
        protected void coolDown() throws Exception {
            synchronized(__actions) {
                java.util.Queue<Object> __action = new java.util.LinkedList<Object>();
                __action.add("coolDown");
                __actions.add(__action);
                __actions.notifyAll();
             }
        }
        
        protected void stop() throws Exception {
            synchronized(__actions) {
                java.util.Queue<Object> __action = new java.util.LinkedList<Object>();
                __action.add("stop");
                __actions.add(__action);
                __actions.notifyAll();
             }
        }
        
        protected void warmUp() throws Exception {
            synchronized(__actions) {
                java.util.Queue<Object> __action = new java.util.LinkedList<Object>();
                __action.add("warmUp");
                __actions.add(__action);
                __actions.notifyAll();
             }
        }
    }
    
    Proxy proxy;
    
    HVACSystemMock(ServiceConfiguration serviceConfiguration,
            java.lang.String idValue,
            java.lang.String locationValue,
            java.lang.String userValue) {
        this.proxy = new Proxy(serviceConfiguration, idValue, locationValue, userValue);
    }
    
    
    // Code for the attribute id from device Device
    /**
     * Set the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @param newIdValue the new value of <code>id</code>
     * @return this for fluent interface
     */
    public HVACSystemMock id(java.lang.String newIdValue) {
        proxy._updateId(newIdValue);
        return this;
    }
    // End of code for the attribute id from device Device
    
    // Code for the attribute location from device PhysicalDevice
    /**
     * Set the value of the <code>location</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute location as String;
     * </pre>
     * @param newLocationValue the new value of <code>location</code>
     * @return this for fluent interface
     */
    public HVACSystemMock location(java.lang.String newLocationValue) {
        proxy._updateLocation(newLocationValue);
        return this;
    }
    // End of code for the attribute location from device PhysicalDevice
    
    // Code for the attribute user from device PhysicalDevice
    /**
     * Set the value of the <code>user</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute user as String;
     * </pre>
     * @param newUserValue the new value of <code>user</code>
     * @return this for fluent interface
     */
    public HVACSystemMock user(java.lang.String newUserValue) {
        proxy._updateUser(newUserValue);
        return this;
    }
    // End of code for the attribute user from device PhysicalDevice
    
    // Code for source isAlive from device Device
    /**
     * Publish the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @param newIsAliveValue the new value for the source <code>isAlive</code>
     * @return this for fluent interface
     */
    public HVACSystemMock isAlive(java.lang.Boolean newIsAliveValue) {
        proxy._publishIsAlive(newIsAliveValue);
        return this;
    }
    
    private java.lang.Boolean __isAlive = null;
    /**
     * Set the value (without publication) of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @param newIsAliveValue the new value for the source <code>isAlive</code>
     * @return this for fluent interface
     */
    public HVACSystemMock setIsAlive(java.lang.Boolean newIsAliveValue) {
        __isAlive = newIsAliveValue;
        return this;
    }
    // End of code for source isAlive from device Device
    
    // Code for source status from device HVACSystem
    /**
     * Publish the value of source <code>status</code> from device <code>HVACSystem</code>.
     * 
     * <pre>
     * source status as HVACStatus;
     * </pre>
     * @param newStatusValue the new value for the source <code>status</code>
     * @return this for fluent interface
     */
    public HVACSystemMock status(fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus newStatusValue) {
        proxy._publishStatus(newStatusValue);
        return this;
    }
    
    private fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus __status = null;
    /**
     * Set the value (without publication) of source <code>status</code> from device <code>HVACSystem</code>.
     * 
     * <pre>
     * source status as HVACStatus;
     * </pre>
     * @param newStatusValue the new value for the source <code>status</code>
     * @return this for fluent interface
     */
    public HVACSystemMock setStatus(fr.inria.phoenix.diasuite.framework.datatype.hvacstatus.HVACStatus newStatusValue) {
        __status = newStatusValue;
        return this;
    }
    // End of code for source status from device HVACSystem
    
    private java.util.Queue<java.util.Queue<Object>> __actions = new java.util.LinkedList<java.util.Queue<Object>>();
    
    /**
     * Check that the <code>coolDown</code> order from the <code>Regulate</code> action
     * defined in device HVACSystem was called.
     * 
     * 
     * <pre>
     * coolDown();
     * </pre>    @return true if the action happened with the given parameters
     */
    public boolean expectCoolDown() {
        try {
            synchronized(__actions) {
                java.util.Queue<Object> __action = __actions.poll();
                if(__action == null) {
                    __actions.wait(TIMEOUT);
                    __action = __actions.poll();
                }
                if(__action == null)
                    return false;
                if(!("coolDown".equals(__action.poll())))
                    return false;
                return true;
            }
         } catch(InterruptedException e) {
             return false;
         }
    }
    
    /**
     * Check that the <code>stop</code> order from the <code>Regulate</code> action
     * defined in device HVACSystem was called.
     * 
     * 
     * <pre>
     * stop();
     * </pre>    @return true if the action happened with the given parameters
     */
    public boolean expectStop() {
        try {
            synchronized(__actions) {
                java.util.Queue<Object> __action = __actions.poll();
                if(__action == null) {
                    __actions.wait(TIMEOUT);
                    __action = __actions.poll();
                }
                if(__action == null)
                    return false;
                if(!("stop".equals(__action.poll())))
                    return false;
                return true;
            }
         } catch(InterruptedException e) {
             return false;
         }
    }
    
    /**
     * Check that the <code>warmUp</code> order from the <code>Regulate</code> action
     * defined in device HVACSystem was called.
     * 
     * 
     * <pre>
     * warmUp();
     * </pre>    @return true if the action happened with the given parameters
     */
    public boolean expectWarmUp() {
        try {
            synchronized(__actions) {
                java.util.Queue<Object> __action = __actions.poll();
                if(__action == null) {
                    __actions.wait(TIMEOUT);
                    __action = __actions.poll();
                }
                if(__action == null)
                    return false;
                if(!("warmUp".equals(__action.poll())))
                    return false;
                return true;
            }
         } catch(InterruptedException e) {
             return false;
         }
    }
}
