package fr.inria.phoenix.scenario.airconditionmanager.controller;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.hvacregulation.HVACRegulationValue;
import fr.inria.phoenix.diasuite.framework.controller.hvaccontroller.AbstractHVACController;
import fr.inria.phoenix.diasuite.framework.datatype.temperaturelevel.TemperatureLevel;

public class HVACController extends AbstractHVACController {

	public HVACController(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
	}

	@Override
	protected void onHVACRegulation(HVACRegulationValue hVACRegulation,
			DiscoverForHVACRegulation discover) {

		String location = hVACRegulation.indices().location();

		TemperatureLevel temperatureValue = hVACRegulation.value();

		HVACSystemProxyForHVACRegulation hvacSystem = discover.hVACSystems()
				.whereLocation(location).anyOne();

		switch (temperatureValue) {

		case HOT: {
			hvacSystem.coolDown();
			System.out.println("Cooling down !");
			break;
		}

		case COLD: {
			hvacSystem.warmUp();
			System.out.println("Warming up !");
			break;
		}

		case OK: {
			hvacSystem.stop();
			System.out.println("Stopping !");
			break;
		}

		default:
			break;
		}

	}

}
